#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
const int MAX_N=1028;
struct V
{
    int l,r;
    vector<int>s;
};
V tree[MAX_N*80];
int num=1;
int Init(int ind,int l,int r)
{
    int cur=num++;
    if(l==r)
    {
        tree[cur].s.resize(2);
        return num;
    }
    int mid=(l+r)/2;

    tree[cur].l=Init(tree[cur].l,l,mid);
    tree[cur].r=Init(tree[cur].r,mid+1,r);

    tree[cur].s.clear();

    return num;
}
int Update(int ind,int l,int r,int idx,int c)
{
    int cur=num++;

    if(l==r)
    {
        tree[cur].s.clear();
        tree[cur].s.push_back(c);
        return num;
    }

    int mid=(l+r)/2;

    tree[cur].l=tree[ind].l;
    tree[cur].r=tree[ind].r;

    if(idx<=mid)tree[cur].l=Update(tree[cur].l,l,mid,idx,c);
    else tree[cur].r=Update(tree[cur].r,mid+1,r,idx,c);

    tree[cur].s.clear();

    for(int x:tree[tree[cur].l].s)
    {
        tree[cur].s.push_back(x);
    }
    for(int x:tree[tree[cur].r].s)
    {
        tree[cur].s.push_back(x);
    }
    return num;
}
int Query(int ind,int l,int r,int ql,int qr,int c1,int c2)
{
    if(qr<ql)return 0;
    if(c2<c1)return 0;
    if(ql<=l && r<=qr)
    {
        int pos1=-1,pos2=-1;
        int le=0,re=tree[ind].s.size()-1;
        while(le<=re)
        {
            int mid=(le+re)/2;
            if(tree[ind].s[mid]>=c1)
            {
                pos1=mid;
                re=mid-1;
            }
            else le=mid+1;
        }
        if(pos1==-1)return 0;

        le=0;
        re=tree[ind].s.size()-1;
        while(le<=re)
        {
            int mid=(le+re)/2;
            if(tree[ind].s[mid]<=c2)
            {
                pos2=mid;
                le=mid+1;
            }
            else re=mid-1;
        }

        return pos2-pos1+1;
    }
    int mid=(l+r)/2;
    int ans=0;
    if(ql<=l)ans+=Query(tree[ind].l,l,mid,ql,qr,c1,c2);
    if(mid<qr)ans+=Query(tree[ind].r,mid+1,r,ql,qr,c1,c2);
    return ans;
}
int root[MAX_N*MAX_N];
vector<pair<int,pair<int,int>>>v;
vector<pair<int,int>>mom;
//seg

int n,m;
int a[MAX_N][MAX_N];
//init

int xo[MAX_N][MAX_N];
int p[MAX_N][MAX_N];

int ans_xor;
int ans_sum;
int ans_min;

int calc_xor(int i1,int j1,int i2,int j2)
{
    return (xo[i2][j2]^xo[i2][j1-1])^(xo[i1-1][j2]^xo[i1-1][j1-1]);
}

int calc_sum(int i1,int j1,int i2,int j2)
{
    return (p[i2][j2]-p[i2][j1-1]-p[i1-1][j2]+p[i1-1][j1-1]);
}

bool calc_mi(int i1,int j1,int i2,int j2,int ind)
{
    return (Query(ind,1,n,1,i2,1,j2)-Query(ind,1,n,1,i2,1,j1-1)-Query(ind,1,n,1,i1-1,1,j2)
            +Query(ind,1,n,1,i1-1,1,j1-1));
}

int main ()
{
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>a[i][j];
            p[i][j]=p[i-1][j]+p[i][j-1]-p[i-1][j-1]+a[i][j];
            xo[i][j]=(xo[i-1][j]^xo[i][j-1]^xo[i-1][j-1]^a[i][j]);
            v.push_back({a[i][j],{i,j}});
        }
    }

    sort(v.begin(),v.end());

    mom.push_back({1,v[0].first});

    for(int i=1;i<v.size();i++)
    {
        if(v[i].first!=v[i-1].first)mom.push_back({i+1,v[i].first});
    }

    root[0]=1;

    int cu=Init(1,1,n);

    for(int i=1;i<=v.size();i++)
    {
        root[i]=cu;
        cu=Update(root[i-1],1,n,v[i-1].second.first,v[i-1].second.second);
    }

    //return 0;

    int q;
    cin>>q;
    int r1,r2,c1,c2;
    while(q--)
    {
        cin>>r1>>c1>>r2>>c2;

        int l=0,r=mom.size()-1;
        int MIn;

        while(l<=r)
        {
            int mid=(l+r)/2;
            if(calc_mi(r1,c1,r2,c2,mom[mid].first))
            {
                MIn=mom[mid].second;
                r=mid-1;
            }
            else l=mid+1;
        }

        ans_min+=MIn;
        ans_sum+=calc_sum(r1,c1,r2,c2);
        ans_xor+=calc_xor(r1,c1,r2,c2);
    }

    cout<<ans_sum<<" "<<ans_xor<<" "<<ans_min<<"\n";


    return 0;
}

