#include<iostream>

using namespace std;

short n, m, arr[1025][1025], st[1025][11][1025][11];
int pref[1025][1025], prefSum[1025][1025];
long long ans;
int q;

void buildSparse()
{
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            st[i][0][j][0] = arr[i][j];
        }
    }
    for(int i = 0; i < n; i ++)
    {
        for(int c = 1; (1 << c) <= m; c ++)
        {
            for(int j = 0; j + (1 << c) <= m; j ++)
            {
                st[i][0][j][c] = min(st[i][0][j][c - 1], st[i][0][j + (1 << (c - 1))][c - 1]);
            }
        }
    }
    for(int r = 1; (1 << r) <= n; r ++)
    {
        for(int i = 0; i + (1 << r) <= n; i ++)
        {
            for(int c = 0; (1 << c) <= m; c ++)
            {
                for(int j = 0; j + (1 << c) <= m; j ++)
                {
                    st[i][r][j][c] = min(st[i][r - 1][j][c], st[i + (1 << (r - 1))][r - 1][j][c]);
                }
            }
        }
    }
}
int pw(int p)
{
    if(p == 1) return 0;
    int ret = 0;
    while(p != 0)
    {
        p /= 2;
        ret ++;
    }
    return ret - 1;
}
int query(int l, int r, int u, int d)
{
    if(r < l) swap(l, r);
    if(d < u) swap(u, d);
    int x = abs(r - l) + 1, y = abs(u - d) + 1;
    int pwX = pw(x);
    int pwY = pw(y);
    return min(min(st[u][pwY][l][pwX], st[u][pwY][r - (1 << (pwX)) + 1][pwX]), min(st[d - (1 << pwY) + 1][pwY][l][pwX], st[d - (1 << pwY) + 1][pwY][r - (1 << (pwX)) + 1][pwX]));
}
void buildPref()
{
    for(int i = 0; i < n; i ++)
    {
        pref[i][0] = arr[i][0];
        prefSum[i][0] = arr[i][0];
        for(int j = 1; j < m; j ++)
        {
            pref[i][j] = pref[i][j - 1] ^ arr[i][j];
            prefSum[i][j] = prefSum[i][j - 1] + arr[i][j];
        }
    }
}
pair<int, int> queryS(int l, int r, int u, int d)
{
    if(u > d) swap(u, d);
    int sum = 0, xx;
    for(int i = u; i <= d; i ++)
    {
        xx ^= (pref[i][r]);
        if(l) xx ^= pref[i][l - 1];
        sum += (prefSum[i][r]);
        if(l) sum += prefSum[i][l - 1];
    }
    return {xx, sum};
}
void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i = 0; i < n; i ++)
    {
        for(int j = 0; j < m; j ++)
        {
            cin>>arr[i][j];
        }
    }
}
void solve()
{
    cin>>q;
    int x, y, z, w;
    int sumall = 0, xxall = 0;
    while(q --)
    {
       cin>>x>>y>>z>>w;
       ans += query(y - 1, w - 1, x - 1, z - 1);
       auto cur = queryS(y - 1, w - 1, x - 1, z - 1);
       sumall += cur.second;
       xxall += cur.first;
    }
    cout<<sumall<<" "<<xxall<<" "<<ans<<endl;
}
int main()
{
    read();
    buildSparse();
    buildPref();
    solve();
    return 0;
}
