#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int MAX_N = 1024 + 42;
const int INF = 1e9;
const int mod = 1e9 + 7;

struct Node{
    int min;
    int XOR;
    int sum;

    Node(){
        min = INF;
        XOR = 0;
        sum = 0;
    }
} tree[MAX_N][MAX_N];

Node operator +( const Node& a, const Node& b ){
    Node nas;
    nas.sum = a.sum + b.sum;
    nas.XOR = a.XOR ^ b.XOR;
    nas.min = std::min(a.min, b.min);
    return nas;
}

int a[MAX_N][MAX_N];

int N, M;

void buildY(int x, int lX, int rX, int curr, int lY, int rY){
    //std::cerr<<"    "<<x<<"    "<<curr<<" "<<lY<<" "<<rY<<"\n";
    if( lY == rY ){
        if( lX == rX ){
    //        std::cerr<<" edno\n ";
            tree[x][curr].min = tree[x][curr].XOR = tree[x][curr].sum = a[lX][lY];
        }else{
    //        std::cerr<<" big merge\n ";
            tree[x][curr] = tree[2*x][curr] + tree[2*x+1][curr];
        }
        return;
    }
    int m = (lY + rY) >> 1;
    buildY( x, lX, rX, 2*curr, lY, m );
    buildY( x, lX, rX, 2*curr+1, m+1, rY );

    tree[x][curr] = tree[x][curr*2] + tree[x][2*curr+1];
}

void buildX( int x, int l, int r ){
    //std::cerr<<" ! "<<x<<" "<<l<<" "<<r<<"\n";
    if( l == r ){
    //    buildY( x, l, r, 1, 0, M-1 );
        return;
    }
    int m = (l+r) >> 1;
    buildX( 2*x, l, m );
    buildX( 2*x+1, m+1, r );

    buildY( 2*x, l, m, 1, 0, M-1 );
    buildY( 2*x +1, m+1, r, 1, 0, M-1 );
}

Node queryY(int x, int l, int r, int curr, int lx, int rx ){
    //std::cerr<<"     # "<<x<<" "<<l<<" "<<r<<"      "<<curr<<" "<<lx<<" "<<rx<<"\n";
    if( l > rx || lx > r ){
    //    std::cerr<<"         otvan\n ";
        return Node();
    }
    if( lx >= l and rx <= r ){
    //    std::cerr<<"      vatre \n";
   //     std::cout<<tree[x][curr].sum<<" "<<tree[x][curr].XOR<<" "<<tree[x][curr].min<<"\n";
        return tree[x][curr];
    }
    int m = (lx + rx) >> 1;
    Node left = queryY( x, l, r, curr*2, lx, m );
    Node right = queryY(x, l, r, curr*2+1, m+1, rx );

    return left + right;
}

Node queryX( int l, int r, int x, int lx, int rx, int ly, int ry ){
    //std::cerr<<l<<" "<<r<<"     "<<x<<" "<<lx<<""<<rx<<"\n";
    if( l > rx || lx > r ){
    //        std::cerr<<"otvan\n ";
            return Node();
    }
    if( lx >= l and rx <= r ){
    //    std::cerr<<"vatre \n";
        return queryY( x, ly, ry, 1, 0, M-1 );
    }
    int m = (lx + rx) >>1;
    Node left = queryX(l, r, 2*x, lx, m, ly, ry);
    Node right = queryX(l, r, 2*x+1, m+1, rx, ly, ry );

    return left + right;
}

int main () {

#ifndef LOCAL
    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
#endif

    std::cin>>N>>M;

    for( int i=0 ; i<N ; i++ ){
        for( int j=0 ; j<M ; j++ ){
            std::cin>>a[i][j];
        }
    }

    buildX( 1, 0, N-1 );
    buildY( 1, 0, N-1, 1, 0, M-1 );

    int q;
    std::cin>>q;

    Node nas;
    nas.sum = nas.min = nas.XOR = 0;
    while( q-- ){
        int x1, y1, x2, y2;
        std::cin>>x1>>y1>>x2>>y2;
        //std::cin>>y1>>x1>>y2>>x2;
        x1--; x2--; y1--; y2--;
        Node currNas = queryX( x1, x2, 1, 0, N-1, y1, y2 );
        //nas = nas + currNas;
        nas.sum += currNas.sum;
        nas.min += currNas.min;
        nas.XOR += currNas.XOR;
    //    std::cerr<<" ! "<<currNas.sum<<" "<<currNas.XOR<<" "<<currNas.min<<"\n";
    }
    std::cout<<nas.sum<<" "<<nas.XOR<<" "<<nas.min<<"\n";

    return 0;
}
/*
    5 5
    1 3 6 3 6
    1 4 5 1 1
    5 8 6 1 3
    4 6 9 9 8
    0 0 3 1 2
    3
    2 2 4 4
    1 5 4 5
    1 1 5 1
*/
