#include <bits/stdc++.h>
using namespace std;
long long sums[1024][1024], xors[1024][1024], mins[1024][4096];
void buildTree(long long tree[], long long arr[], int parent, int first, int last) {
    if(first == last) {
        tree[parent] = arr[first];
        return;
    }

    int mid = (first + last) / 2;
    buildTree(tree, arr, 2 * parent, first, mid);
    buildTree(tree, arr, 2 * parent + 1, mid + 1, last);
    tree[parent] = min(tree[2 * parent], tree[2 * parent + 1]);
}

long long query(long long tree[], int parent, int first, int last, int from, int to) {
    if(first > to || last < from) return INT_MAX;

    if(first >= from && last <= to) {
        return tree[parent];
    }

    long long m = INT_MAX;
    int mid = (first + last) / 2;
    m = min(m, query(tree, 2 * parent, first, mid, from, to));
    m = min(m, query(tree, 2 * parent + 1, mid + 1, last, from, to));

    return m;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int N, M;
    cin >> N >> M;
    long long table[N][M];
    for(int i = 0; i < N; i++) {
        long long rowsum = 0, rowx = 0;
        for(int j = 0; j < M; j++) {
            cin >> table[i][j];
            rowsum += table[i][j];
            rowx ^= table[i][j];
            if(i == 0 && j == 0) {
                sums[i][j] = table[i][j];
                xors[i][j] = table[i][j];
                continue;
            }
            if(i == 0) {
                sums[i][j] = rowsum;
                xors[i][j] = rowx;
                continue;
            }
            if(j == 0) {
                sums[i][j] = sums[i - 1][j] + rowsum;
                xors[i][j] = (xors[i - 1][j] ^ rowx);
                continue;
            }
            sums[i][j] = sums[i - 1][j] + rowsum;
            xors[i][j] = (xors[i - 1][j] ^ rowx);
        }
        buildTree(mins[i], table[i], 1, 0, M - 1);
    }

    /*for(int i = 0; i < N; i++) {
        for(int j = 0; j < M; j++) {
            cout << sums[i][j] << endl;
        }
        cout << endl;
    }*/

    int q;
    cin >> q;
    long long s = 0, x = 0, m = 0;
    map<pair<pair<int, int>, pair<int, int>>, pair<pair<int, int>, int>> res;
    while(q--) {
        int r1, c1, r2, c2;
        cin >> r1 >> c1 >> r2 >> c2;
        r1--; c1--; r2--; c2--;
        auto sr = res.find({{r1, c1}, {r2, c2}});
        if(sr != res.end()) {
            int currs = sr->second.first.first, currx = sr->second.first.second, currm = sr->second.second;
            s += currs;
            x += currx;
            m += currm;
            continue;
        }
        long long currs = 0, currx = 0, currm = INT_MAX;
        if(r1 != 0) {
            currs = sums[r2][c2] - sums[r1 - 1][c2];
            currx = (xors[r2][c2] ^ xors[r1 - 1][c2]);
        } else {
            currs = sums[r2][c2];
            currx = xors[r2][c2];
        }
        if(c1 != 0) {
            currs -= sums[r2][c1 - 1];
            currx ^= xors[r2][c1 - 1];
            if(r1 != 0) {
                currs += sums[r1 - 1][c1 - 1];
                currx ^= xors[r1 - 1][c1 - 1];
            }
        }
        for(int i = r1; i <= r2; i++) {
            currm = min(currm, query(mins[i], 1, 0, M - 1, c1, c2));
        }
        s += currs;
        x += currx;
        m += currm;
        res.insert(make_pair(make_pair(make_pair(r1, c1), make_pair(r2, c2)), make_pair(make_pair(currs, currx), currm)));
    }

    cout << s << " " << x << " " << m;




    return 0;
}
