#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 2e5 + 50;


struct SegmentTreeMAX
{
    int n, tree[MAXN*4];
    SegmentTreeMAX()
    {
        memset(tree, 0, sizeof(tree));
    }

    SegmentTreeMAX(int n):SegmentTreeMAX()
    {
        this->n = n;
    }

    void Recalculate(int node)
    {
        tree[node] = max(tree[node*2], tree[node*2+1]);
    }

    int QueryInternal(int qL, int qR, int node, int L, int R)
    {
        if (L > qR || R < qL)
            return 0;

        if (qL <= L && R <= qR)
            return tree[node];

        return max(QueryInternal(qL, qR, node*2, L, (L+R)/2),
                 QueryInternal(qL, qR, node*2+1, (L+R)/2+1, R));
    }

    void BuildInternal(int *arr, int node, int l, int r)
    {
        if (l == r)
        {
            tree[node] = arr[l];
            return;
        }

        BuildInternal(arr, node*2, l, (l+r)/2);
        BuildInternal(arr, node*2+1, (l+r)/2 + 1, r);

        Recalculate(node);
    }

    void Build(int *arr)
    {
        BuildInternal(arr, 1, 0, n-1);
    }

    int Query(int qL, int qR)
    {
        return QueryInternal(qL, qR, 1, 0, n-1);
    }
};

struct SegmentTreeMIN
{
    int n, tree[MAXN*4];
    SegmentTreeMIN()
    {
        memset(tree, 0, sizeof(tree));
    }

    SegmentTreeMIN(int n):SegmentTreeMIN()
    {
        this->n = n;
    }

    void Recalculate(int node)
    {
        tree[node] = min(tree[node*2], tree[node*2+1]);
    }

    int QueryInternal(int qL, int qR, int node, int L, int R)
    {
        if (L > qR || R < qL)
            return INT_MAX;

        if (qL <= L && R <= qR)
            return tree[node];

        return min(QueryInternal(qL, qR, node*2, L, (L+R)/2),
                 QueryInternal(qL, qR, node*2+1, (L+R)/2+1, R));
    }

    void BuildInternal(int *arr, int node, int l, int r)
    {
        if (l == r)
        {
            tree[node] = arr[l];
            return;
        }

        BuildInternal(arr, node*2, l, (l+r)/2);
        BuildInternal(arr, node*2+1, (l+r)/2 + 1, r);

        Recalculate(node);
    }

    void Build(int *arr)
    {
        BuildInternal(arr, 1, 0, n-1);
    }

    int Query(int qL, int qR)
    {
        return QueryInternal(qL, qR, 1, 0, n-1);
    }
};

int a[MAXN], b[MAXN];
int copyArr[MAXN];

bool used[MAXN];
map <int, int> hashMap;
int inverseHashMap[MAXN];
vector <int> possitions[MAXN];

struct Segment
{
    int l, r, val;
    Segment(){}
    Segment(int l, int r, int val)
        :l(l), r(r), val(val){}

    friend bool operator< (const Segment& a, const Segment& b)
    {
        if (a.val != b.val)
            return a.val < b.val;
    }
};

vector <Segment> segments;
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;

    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        copyArr[i] = a[i];
    }

    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
        copyArr[i+n] = b[i];
    }

    SegmentTreeMAX *treeMAX = new SegmentTreeMAX(n);
    SegmentTreeMIN *treeMIN = new SegmentTreeMIN(n);

    sort(copyArr, copyArr+2*n);

    k = 0;
    for (int i = 0; i < 2*n; i++)
    {
        if (hashMap.find(copyArr[i]) == hashMap.end())
        {
            hashMap[copyArr[i]] = k;
            inverseHashMap[k] = copyArr[i];
            k++;
        }
    }

    for (int i = 0; i < n; i++)
    {
        a[i] = hashMap[a[i]];
        b[i] = hashMap[b[i]];

        possitions[a[i]].push_back(i);
        //cout << a[i] << " " << b[i] << endl;
    }

    treeMAX->Build(a);
    treeMIN->Build(b);

    int j = 0, k, l, r, val;
    for (int i = 0; i < n; i = j+1)
    {
        j = i;

        while (j < n && b[i] == b[j])
            j++;

        j--;

        for (k = 0; k < possitions[b[i]].size(); k++)
        {
            //cout << b[i] << "-> " << possitions[b[i]][k] << endl;
            l = min(possitions[b[i]][k], i);
            r = max(possitions[b[i]][k], j);
            val = b[i];

            //cout << l << " " << r << " " << val << " " << tree->Query(l, r) << "!" << endl;
            if (treeMAX->Query(l, r) > val)
                continue;

            if (treeMIN->Query(l, r) < val)
                continue;

            if (l == r)
                continue;

            segments.push_back(Segment(l, r, val));
        }
    }

    sort(segments.begin(), segments.end());
    for (int i = 0; i < segments.size(); i++)
    {
        for (int j = segments[i].l; j <= segments[i].r; j++)
            a[j] = segments[i].val;
    }

    for (int i = 0; i < n; i++)
    {
        if (a[i] != b[i])
        {
            cout << -1 << endl;
            return 0;
        }
    }

    cout << segments.size() << endl;

    for (int i = 0; i < segments.size(); i++)
    {
        cout << segments[i].l << " " << segments[i].r << endl;
    }

    return 0;
}
