#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1025;
const int MAXLOG = 11;

int n, m;
int table[MAXN][MAXN];
int SUM[MAXN][MAXN];
int XOR[MAXN][MAXN];
int MIN[MAXN][MAXN][MAXLOG][MAXLOG];

void Precompute()
{
    SUM[1][1] = XOR[1][1] = table[1][1];

    for (int i = 2; i <= m; i++)
    {
        SUM[1][i] = SUM[1][i-1] + table[1][i];
        XOR[1][i] = XOR[1][i-1] ^ table[1][i];
    }

    for (int i = 2; i <= n; i++)
    {
        SUM[i][1] = SUM[i-1][1] + table[i][1];
        XOR[i][1] = XOR[i-1][1] ^ table[i][1];
    }

    for (int i = 2; i <= n; i++)
    {
        for (int j = 2; j <= m; j++)
        {
            SUM[i][j] = SUM[i-1][j] + SUM[i][j-1] - SUM[i-1][j-1] + table[i][j];
            XOR[i][j] = XOR[i-1][j] ^ XOR[i][j-1] ^ XOR[i-1][j-1] ^ table[i][j];
        }
    }

}

int QuerySUM(int x1, int y1, int x2, int y2)
{
    return SUM[x2][y2] - SUM[x1-1][y2] - SUM[x2][y1-1] + SUM[x1-1][y1-1];
}
int QueryXOR(int x1, int y1, int x2, int y2)
{
    return XOR[x2][y2] ^ XOR[x1-1][y2] ^ XOR[x2][y1-1] ^ XOR[x1-1][y1-1];
}
int QueryMIN(int x1, int y1, int x2, int y2)
{
    return XOR[x2][y2] ^ XOR[x1-1][y2] ^ XOR[x2][y1-1] ^ XOR[x1-1][y1-1];
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            cin >> table[i][j];
        }
    }

    Precompute();

    int q;
    cin >> q;

    int totalXOR = 0, totalSUM = 0, totalMIN = 0;
    for (int i = 0; i < q; i++)
    {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;

        totalSUM += QuerySUM(x1, y1, x2, y2);
        totalXOR += QueryXOR(x1, y1, x2, y2);
        totalMIN += QueryMIN(x1, y1, x2, y2);
    }

    cout << totalSUM << " " << totalXOR << " " << totalMIN << endl;
    return 0;
}
