#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1025;
const int MAXLOG = 11;

int n, m;
int table[MAXN][MAXN];
int LOG[MAXN];
int64_t SUM[MAXN][MAXN];
int XOR[MAXN][MAXN];
short MIN[MAXN][MAXN][MAXLOG][MAXLOG];

void Precompute()
{
    int i, j, log1, log2;
    SUM[1][1] = XOR[1][1] = table[1][1];

    for (i = 2; i <= m; i++)
    {
        SUM[1][i] = SUM[1][i-1] + table[1][i];
        XOR[1][i] = XOR[1][i-1] ^ table[1][i];
    }

    for (i = 2; i <= n; i++)
    {
        SUM[i][1] = SUM[i-1][1] + table[i][1];
        XOR[i][1] = XOR[i-1][1] ^ table[i][1];
    }

    for (i = 2; i <= n; i++)
    {
        for (j = 2; j <= m; j++)
        {
            SUM[i][j] = SUM[i-1][j] + SUM[i][j-1] - SUM[i-1][j-1] + table[i][j];
            XOR[i][j] = XOR[i-1][j] ^ XOR[i][j-1] ^ XOR[i-1][j-1] ^ table[i][j];
        }
    }

    LOG[1] = 0;
    for (i = 2; i < MAXN; i++)
    {
        LOG[i] = LOG[i/2] + 1;
    }

    for (i = 1; i <= n; i++)
    {

        for (j = 1; j <= m; j++)
            MIN[i][j][0][0] = table[i][j];

        for (log2 = 1; log2 < MAXLOG; log2++)
        {
            for (j = 1; j <= m; j++)
            {
                if (j + (1<<(log2-1)) > m)
                    MIN[i][j][0][log2] = MIN[i][j][0][log2-1];

                else
                {
                    MIN[i][j][0][log2] = min(MIN[i][j][0][log2-1],
                                             MIN[i][j + (1<<(log2-1))][0][log2-1]);
                }
            }
        }
    }

    for (j = 1; j <= m; j++)
    {
        for (i = 1; i <= n; i++)
            MIN[i][j][0][0] = table[i][j];

        for (log1 = 1; log1 < MAXLOG; log1++)
        {
            for (i = 1; i <= n; i++)
            {
                if (i + (1<<(log1-1)) > n)
                    MIN[i][j][log1][0] = MIN[i][j][log1-1][0];

                else
                {
                    MIN[i][j][log1][0] = min(MIN[i][j][log1-1][0],
                                             MIN[i+(1<<(log1-1))][j][log1-1][0]);
                }
            }

        }
    }

    for (log1 = 1; log1 < MAXLOG; log1++)
    {
        for (log2 = 1; log2 < MAXLOG; log2++)
        {
            for (i = 1; i <= n; i++)
            {
                for (j = 1; j <= m; j++)
                {
                    if (j + (1<<(log2-1)) > m)
                        MIN[i][j][log1][log2] = MIN[i][j][log1][log2-1];

                    else
                    {
                        MIN[i][j][log1][log2] = min(MIN[i][j][log1][log2-1],
                                                    MIN[i][j + (1<<(log2-1))][log1][log2-1]);
                    }
                }
            }
        }
    }
}

int64_t QuerySUM(int x1, int y1, int x2, int y2)
{
    return SUM[x2][y2] - SUM[x1-1][y2] - SUM[x2][y1-1] + SUM[x1-1][y1-1];
}
int64_t QueryXOR(int x1, int y1, int x2, int y2)
{
    return XOR[x2][y2] ^ XOR[x1-1][y2] ^ XOR[x2][y1-1] ^ XOR[x1-1][y1-1];
}

int lX, lY, ans;
int64_t QueryMIN(int x1, int y1, int x2, int y2)
{
    lX = LOG[x2-x1+1];
    lY = LOG[y2-y1+1];

    ans = min(MIN[x1][y1][lX][lY], MIN[x2 - (1<<lX)+1][y1][lX][lY]);
    ans = min(ans, MIN[x1][y2 - (1<<lY) + 1][lX][lY]);
    ans = min(ans, MIN[x2 - (1<<lX) + 1][y2 - (1<<lY) + 1][lX][lY]);

    //cout << "! " << ans  << endl;
    return ans;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int i, j;
    cin >> n >> m;
    for (i = 1; i <= n; i++)
    {
        for (j = 1; j <= m; j++)
        {
            cin >> table[i][j];
        }
    }

    Precompute();

    int q;
    cin >> q;

    int64_t totalXOR = 0, totalSUM = 0, totalMIN = 0;
    int x1, y1, x2, y2;

    for (i = 0; i < q; i++)
    {
        cin >> x1 >> y1 >> x2 >> y2;

        totalSUM += QuerySUM(x1, y1, x2, y2);
        totalXOR += QueryXOR(x1, y1, x2, y2);
        totalMIN += QueryMIN(x1, y1, x2, y2);
    }

    cout << totalSUM << " " << totalXOR << " " << totalMIN << endl;
    return 0;
}
