#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1e5 + 50;

int n, k;

struct Segment
{
    int x, y1, y2, type, ind;
    Segment(){}
    Segment(int x, int y1, int y2, int type)
        :x(x), y1(y1), y2(y2), type(type){}

};

bool cmp(const Segment& a, const Segment& b)
{
    if (a.x != b.x)
        return a.x < b.x;

    return a.type < b.type;
}

vector <Segment> segments;

struct SegmentTree
{
    int tree[MAXN*8], n;
    SegmentTree(int n)
        :n(n){}

    void Recalculate(int node)
    {
        tree[node] = tree[node*2] + tree[node*2+1];
    }

    void UpdateInternal(int q, int change, int node, int l, int r)
    {
        if (l > q || r < q)
            return;

        if (l == r)
        {
            tree[node] += change;
            return;
        }

        UpdateInternal(q, change, node*2, l, (l+r)/2);
        UpdateInternal(q, change, node*2+1, (l+r)/2+1, r);

        Recalculate(node);
    }

    int QueryInternal(int qL, int qR, int node, int L, int R)
    {
        if (L > qR || R < qL)
            return 0;

        if (qL <= L && R <= qR)
            return tree[node];

        return (QueryInternal(qL, qR, node*2, L, (L+R)/2)+
                 QueryInternal(qL, qR, node*2+1, (L+R)/2+1, R));
    }

    void Update(int q, int change)
    {
        UpdateInternal(q, change, 1, 0, n-1);
    }

    int Query(int qL, int qR)
    {
        return QueryInternal(qL, qR, 1, 0, n-1);
    }
};
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> k;

    for (int i = 0; i < n; i++)
    {
        int x, y;
        cin >> x >> y;

        int newX = (x-y)+MAXN;
        int newY = (x+y)+MAXN;

        int x1 = max(newX-k, 0);
        int x2 = min(newX+k, 2*MAXN-5);
        int y1 = max(newY-k, 0);
        int y2 = min(newY+k, 2*MAXN-5);

        //cout << newX << " " << newY << " > " << endl;
        segments.push_back(Segment(newX, newY, newY, 0));
        segments.push_back(Segment(x1, y1, y2, +1));
        segments.push_back(Segment(x2, y1, y2, -1));
    }

    sort(segments.begin(), segments.end(), cmp);

    int64_t ans = 0;
    SegmentTree *tree = new SegmentTree(2*MAXN);
    for (int i = 0; i < segments.size(); i++)
    {
        //cout << segments[i].x << " " << segments[i].y1 <<  " " << segments[i].y2 << " " << segments[i].type << endl;
        if (segments[i].type == 0)
            tree->Update(segments[i].y1, 1);

        if (segments[i].type == 1)
            ans -= tree->Query(segments[i].y1, segments[i].y2);


        if (segments[i].type == -1)
            ans += tree->Query(segments[i].y1, segments[i].y2);
    }

    cout << ans << endl;

    return 0;
}
