#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 300;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m;
long long a[MAXN][MAXN];
long long prefsum[MAXN][MAXN], prefxor[MAXN][MAXN];
void read_table()
{
    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
            cin >> a[i][j];
    }
}

void build_tables()
{
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            prefsum[i][j] = prefsum[i-1][j] + prefsum[i][j-1] - prefsum[i-1][j-1] + a[i][j];
            prefxor[i][j] = prefxor[i-1][j] ^ prefxor[i][j-1] ^ prefxor[i-1][j-1] ^ a[i][j];
        }
    }
}

long long sum_subtable(int x, int y, int xx, int yy)
{
    return (prefsum[xx][yy] - prefsum[x-1][yy] - prefsum[xx][y-1] + prefsum[x-1][y-1]);
}
long long xor_subtable(int x, int y, int xx, int yy)
{
    return (prefxor[xx][yy] ^ prefxor[x-1][yy] ^ prefxor[xx][y-1] ^ prefxor[x-1][y-1]);
}

long long t[65][MAXN * 4];
void build_tree_row(int row, int i, int l, int r)
{
    if(l == r)
    {
        t[row][i] = a[row][l];
        return;
    }
    int mid = (l + r)/2;
    build_tree_row(row, 2*i, l, mid);
    build_tree_row(row, 2*i+1, mid+1, r);
    t[row][i] = min(t[row][2*i], t[row][2*i+1]);
}
void build_tree()
{
    for (int i = 1; i <= n; ++ i)
        build_tree_row(i, 1, 1, m);
}
int ql, qr;
int query_row(int row, int i, int l, int r)
{
    if(ql > r || qr < l)return (1LL * 1e9);
    if(ql <= l && r <= qr)return t[row][i];
    int mid = (l + r)/2;
    return min(query_row(row, 2*i, l, mid), query_row(row, 2*i+1, mid+1, r));
}
long long s, resx, minn = 0;
void read_queries()
{
    int q;
    cin >> q;
    int x, y, xx, yy;
    while(q --)
    {
        cin >> x >> y >> xx >> yy;
        s += sum_subtable(x, y, xx, yy);
        resx += xor_subtable(x, y, xx, yy);
        int currmin = 1e9 + 10;
        ql = y;
        qr = yy;
        for (int i = x; i <= xx; ++ i)
        {
            currmin = min(currmin, query_row(i, 1, 1, m));
        }
        minn = minn += currmin;
    }
    cout << s << " " << resx << " " << minn << endl;
}
int main()
{
    speed();
    read_table();
    build_tables();
    build_tree();
    read_queries();
    return 0;
}
