#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5+2;
int n, a[maxn], b[maxn], t[4*maxn], ql, qr;
map <int, vector <int> > m;
map <int, vector < pair < int, int > > > in;
vector < pair < int, int > > ans;

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i] = a[r];
        return;
    }
    int mid = (l + r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    t[i] = max(t[2*i], t[2*i+1]);
}

int query(int i, int l, int r)
{
    if (l > qr || r < ql) return 0;
    if (l >= ql && r <= qr) return t[i];
    int mid = (l + r) >> 1 ;
    return max (query(2*i, l, mid), query(2*i+1, mid+1, r));
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i] ;
        m[a[i]].push_back(i);
    }
    make_tree(1, 1, n);

    int cnt = 0;
    for (i=1; i<=n; ++i)
    {
        cin >> b[i] ;
        if (b[i] != b[i-1])
        {
            if (cnt)
                in[b[i-1]].push_back({i-cnt, i-1});

            cnt = 1;
        }
        else
            ++ cnt;
    }
    in[b[n]].push_back({n-cnt+1, n});
}

int bin_search_1(int num, int pos)
{
    int l = 0 , r = (int)(m[num].size())-1;
    int mid = (l+r) >> 1, ans = -1;
    while (l <= r)
    {
        if (m[num][mid] >= pos)
        {
            ans = m[num][mid];
            r = mid - 1;
        }
        else l = mid + 1;
        mid = (l + r) >> 1;
    }
    return ans;
}

int bin_search_2(int num, int pos)
{
    int l = 0 , r = (int)(m[num].size())-1;
    int mid = (l+r) >> 1, ans = -1;
    while (l <= r)
    {
        if (m[num][mid] <= pos)
        {
            ans = m[num][mid];
            l = mid + 1;
        }
        else r = mid - 1;
        mid = (l + r) >> 1;
    }
    return ans;
}

void solve()
{
    map <int, vector < pair < int, int > > > :: iterator it;
    pair <int, vector < pair < int, int > > > p;
    int num, i, len, k1, k2;
    vector < pair < int, int > > v;

    for (it=in.begin(); it!=in.end(); ++it)
    {
        p = (*it);
        num = p.first;
        v = p.second;
        len = v.size();
        //cout << num << "*" << '\n' ;
        for (i=0; i<len; ++i)
        {
            //cout << v[i].first << " " << v[i].second << '\n' ;
            bool lamp = true;
            k1 = bin_search_1(num, v[i].first + 1);
            k2 = bin_search_2(num, v[i].second - 1);
            //cout << k1 << " " << k2 << '\n' ;
            if (k1 == -1 && k2 == -1)
            {
                cout << "-1" << '\n' ;
                exit(0);
            }
            if (k1 != -1)
            {
                ql = v[i].first; qr = max(k1, v[i].second);
                if (query(1, 1, n) == num)
                {
                    ans.push_back({ql, qr});
                    lamp = false;
                }
            }
            if (lamp && k2 != -1)
            {
                ql = min(k2,v[i].first); qr = v[i].second;
                if (query(1, 1, n) == num)
                {
                    ans.push_back({ql, qr});
                    lamp = false;
                }
            }
            if (lamp)
            {
                cout << "-1" << '\n' ;
                exit(0);
            }
        }
    }

    len = ans.size();
    cout << len << '\n' ;
    for (i=0; i<len; ++i)
    {
        cout << ans[i].first-1 << " " << ans[i].second-1 << '\n' ;
    }
}

int main()
{
    read();
    solve();
    return 0;
}