#include <bits/stdc++.h>
using namespace std;

const int maxn = 1030, maxq = 5e5+2;
int n, m, row, ql, qr, a[maxn][maxn], q;
struct tree
{
    int sum = 0;
    int minx = INT_MAX;
    int xorr = 0;
};
tree t[maxn][4*maxn];

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[row][i].sum = a[row][r];
        t[row][i].minx = a[row][r];
        t[row][i].xorr = a[row][r];
        return;
    }
    int mid = (l + r) >> 1 ;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);
    t[row][i].sum = t[row][2*i].sum + t[row][2*i+1].sum;
    t[row][i].minx = min(t[row][2*i].minx, t[row][2*i+1].minx);
    t[row][i].xorr = (t[row][2*i].xorr ^ t[row][2*i+1].xorr);
}

tree query(int i, int l, int r)
{
    tree ans;
    if (l > qr || r < ql) return ans;
    if (l >= ql && r <= qr) return t[row][i];
    int mid = (l + r) >> 1 ;
    tree ans1 = query(2*i, l, mid);
    tree ans2 = query(2*i+1, mid+1, r);
    ans.sum = ans1.sum + ans2.sum;
    ans.minx = min(ans1.minx, ans2.minx);
    ans.xorr = (ans1.xorr ^ ans2.xorr);
    return ans;
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, j;
    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            cin >> a[i][j] ;
        }
    }
}

void init()
{
    int i;
    for (i=1; i<=n; ++i)
    {
        row = i;
        make_tree(1, 1, m);
    }
}

void solve()
{
    cin >> q ;
    int i, j, r1, r2, c1, c2;
    tree p;
    long long res1, res2, res3, ans1 = 0, ans2 = 0, ans3 = 0;
    for (i=1; i<=q; ++ i)
    {
        cin >> r1 >> c1 >> r2 >> c2 ;
        res1 = 0, res2 = 0, res3 = LLONG_MAX;
        for (j=r1; j<=r2; ++j)
        {
            row = j;
            ql = c1; qr = c2;
            p = query(1, 1, m);
            res1 += (long long)(p.sum);
            res3 = min(res3, (long long)(p.minx));
            res2 = (res2 ^ (long long)(p.xorr));
            //cout << res1 << " " << res2 << " " << res3 << '\n' ;
        }
        ans1 += res1, ans2 += res2, ans3 += res3;
    }
    cout << ans1 << " " << ans2 << " " << ans3 << '\n' ;
}

int main()
{
    read();
    init();
    solve();
    return 0;
}